
/* EchoPairServer.java
   Will echo strings sent to it among
   many pairs of clients allowing 1-1
   communication */

import java.net.*;
import java.io.*;


public class FileServer {

    public static int MAX_CLIENTS = 9;
    private static int num_clients = 0;
    private static FileStore db;

    static public int getNumClients(){
	return num_clients;
    }


    static void pullData(Socket client, int id) throws IOException {
	BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream( )));
	PrintWriter out = new PrintWriter(client.getOutputStream( ), true);
	String input;

	System.out.println("server: Pull Data");

	while ((input = in.readLine()) != null) {
	    System.out.println("server: recieving file " + input + " from client " + id);
	   
	    if (input.equals("quit"))
		break;
	    else if(input.equals("print")){
		//System.out.println("printing file database");
		System.out.println(db.toString());
	    }
	    else if(input.contains("query")){
		out.println(db.query(input.substring(input.indexOf(":")+1,input.length())));
	    }
	    else {
		//System.out.println("adding " + input + " from client " + id);
		db.add(id,input);
	    }

	}

	System.out.println("server: closing client");
	out.close();
	in.close();
	client.close();
    }
    
    /* main */
    public static void main(String[] args) throws IOException {
	
	/* create and bind the socket */
	ServerSocket server_socket = null;
	Socket []clients;
	db = new FileStore();
	clients = new Socket[MAX_CLIENTS];
	
	System.out.println("server: attempting to create server socket on 5656");
	
	try {
	    server_socket = new ServerSocket(5656);
	} catch(IOException e) {
	    System.out.println("Could not create server!");
	    System.exit(-1);
	}
	
	System.out.println("server: our info is: " + server_socket.toString( )); 

	/* accept two clients */
	while(true) {
	    System.out.println("server: waiting for a connection");      
	    
	    try {
		clients[num_clients] =  server_socket.accept( );
		//client1 = server_socket.accept( );
	    } catch(IOException e) {
		System.out.println("Could not accept connection!");
		System.exit(-1);
	    }
	    
	    num_clients++;

	    try{
		pullData(clients[num_clients-1],num_clients-1);
	    }
	    catch(Exception e){
		System.out.println("server: unable to pullData from client");
	    }

	    System.out.println("server: received connection");     
	}
    }
}






